<?php
/***************************************************************
 *  Copyright notice
 *  (c) 2012 BVB Media <bvbmedia@gmail.com>
 *  All rights reserved
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 * Hint: use extdeveval to insert/update function index above.
 */
$version=class_exists('t3lib_utility_VersionNumber') ? t3lib_utility_VersionNumber::convertVersionNumberToInteger(TYPO3_version) : \TYPO3\CMS\Core\Utility\VersionNumberUtility::convertVersionNumberToInteger(TYPO3_version);
if ($version<6000000) {
	require_once(PATH_tslib.'class.tslib_pibase.php');
}
/**
 * Plugin '' for the 'multishop_one_step_checkout' extension.
 * @author    BVB Media <bvbmedia@gmail.com>
 * @package    TYPO3
 * @subpackage    tx_multishoponestepcheckout
 */
class tx_multishoponestepcheckout_pi1 extends \TYPO3\CMS\Frontend\Plugin\AbstractPlugin {
	var $prefixId='tx_multishoponestepcheckout_pi1'; // Same as class name
	var $scriptRelPath='class.tx_multishoponestepcheckout_pi1.php'; // Path to this script relative to the extension dir.
	var $extKey='multishop_one_step_checkout'; // The extension key.
	var $pi_checkCHash=true;
	function initLanguage($ms_locallang) {
		$this->pi_loadLL();
		//array_merge with new array first, so a value in locallang (or typoscript) can overwrite values from ../locallang_db
		$this->LOCAL_LANG=array_replace_recursive($this->LOCAL_LANG, is_array($ms_locallang) ? $ms_locallang : array());
		if ($this->altLLkey) {
			$this->LOCAL_LANG=array_replace_recursive($this->LOCAL_LANG, is_array($ms_locallang) ? $ms_locallang : array());
		}
	}
	function construct($ref) {
		mslib_fe::init($ref);
		$this->DOCUMENT_ROOT_ONE_STEP_CHECKOUT=PATH_site.\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::siteRelPath('multishop_one_step_checkout');
		$this->FULL_HTTP_URL_MULTISHOP_ONE_STEP_CHECKOUT=\TYPO3\CMS\Core\Utility\GeneralUtility::getIndpEnv('TYPO3_SITE_URL').\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::siteRelPath('multishop_one_step_checkout');
	}
	function loadConfiguration(&$params, &$ref) {
		$params['settings']['CHECKOUT_TYPE']=\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::siteRelPath($this->extKey).'res/one_step_checkout';
	}
	function getHtmlCartContentsItemPreProc(&$params, &$ref) {
		self::construct($ref);
		// reset it first
		if ($this->ms['MODULES']['ALLOW_CHANGE_PRODUCT_ATTRIBUTES_IN_CART']=='1') {
			//$params['item']['ITEM_NAME'].='<br/><a href="#" class="alter_attributes" rel="'.$params['item']['SHOPPING_CART_KEY'].'">Change</a>';
		}
		/*$params['item']['ITEM_NAME']='';
		// ITEM_NAME
		$params['item']['ITEM_NAME']=$params['product']['products_name'];
		if ($params['product']['products_model']) {
			$params['item']['ITEM_NAME'].=' ('.$params['product']['products_model'].') ';
		}
		// transform into selectbox
		// so the customer can change the [option: values] on checkout review order directly
		$params['item']['ITEM_NAME'].=mslib_fe::showAttributes($params['product']['products_id'], $params['product']['tax_rate'], $params['product']);
		if (is_array($params['product']['attributes'])) {
			foreach ($params['product']['attributes'] as $attributeKey=>$attributeItem) {
				//$params['item']['ITEM_NAME'] .='<br />'.$attributeItem['products_options_name'].': '.$attributeItem['products_options_values_name'];
				if ($attributeItem['options_values_price']>0) {
					if ($this->ms['MODULES']['SHOW_PRICES_INCLUDING_VAT']) {
						$params['subPrices'].=mslib_fe::amount2Cents($attributeItem['options_values_price_including_vat']);
					} else {
						$params['subPrices'].=mslib_fe::amount2Cents($attributeItem['options_values_price']);
					}
				}
				$params['subPrices'].='<br />';
			}
		}
		if ($params['subPrices']) {
			$params['subPrices']='<div class="attribute_prices">'.$params['subPrices'].'</div>';
		}*/
		// ITEM NAME EOF
	}
	function customAjaxPage(&$params, &$ref) {
		self::construct($ref);
		require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('multishop').'pi1/classes/class.tx_mslib_cart.php');
		$mslib_cart=\TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('tx_mslib_cart');
		$mslib_cart->init($this);
		//process start
		$this->ms['page']=$this->get['tx_multishoponestepcheckout_pi1']['page_section'];
		$return_data=array();
		switch ($this->ms['page']) {
			case 'change_product_attributes':
				$return_data=array();
				$cart_key=$this->post['cart_key'];
				//get cart
				$cart=$mslib_cart->getCart();
				if (!empty($cart_key)) {
					$product_id=$cart['products'][$cart_key]['products_id'];
					$tax_rate=$cart['products'][$cart_key]['tax_rate'];
					$product=$cart['products'][$cart_key];
					$return_data['product_name']=$product['products_name'];
					$return_data['product_attributes']=mslib_fe::showAttributes($product_id, $tax_rate, $product);
					$return_data['cart_key']=$cart_key;
				}
				echo json_encode($return_data);
				exit();
				break;
			case 'update_product_attributes':
				$return_data=array();
				$cart_key=$this->post['cart_key'];
				//get cart
				if (!empty($cart_key)) {
					$cart=$mslib_cart->getCart();
					$shopping_cart_item=$cart_key;
					$product_id=$cart['products'][$cart_key]['products_id'];
					$product=$cart['products'][$cart_key];
					$attributes_tax=0;
					if (is_array($this->post['attributes'])) {
						foreach ($this->post['attributes'] as $key=>$value) {
							unset($cart['products'][$shopping_cart_item]['attributes'][$key]);
							if (is_numeric($key)) {
								$str="SELECT * from tx_multishop_products_options o where o.products_options_id='".$key."' and language_id='".$this->sys_language_uid."'";
								$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
								$row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry);
								$continue=0;
								switch ($row['listtype']) {
									case 'checkbox':
										$multiple=1;
										$continue=1;
										break;
									case 'hidden_field':
									case 'textarea':
									case 'input':
										$cart['products'][$shopping_cart_item]['attributes'][$key]=$row;
										$cart['products'][$shopping_cart_item]['attributes'][$key]['options_id']=$key;
										$cart['products'][$shopping_cart_item]['attributes'][$key]['products_options_values_name']=$value;
										$continue=0;
										$multiple=0;
										break;
									default:
										$continue=1;
										$multiple=0;
										break;
								}
								if ($continue) {
									if (is_array($value)) {
										$array=$value;
									} else if ($value) {
										$array=array($value);
									}
									if (count($array)) {
										if ($multiple) {
											// reset first
											unset($cart['products'][$shopping_cart_item]['attributes'][$key]);
										}
										foreach ($array as $item) {
											$str="SELECT * from tx_multishop_products_attributes a, tx_multishop_products_options o, tx_multishop_products_options_values ov where a.products_id='".$product_id."' and a.options_id='".$key."' and a.options_values_id='".$item."' and (o.hide_in_cart=0 or o.hide_in_cart is null) and a.options_id=o.products_options_id and o.language_id='".$this->sys_language_uid."' and ov.language_id='".$this->sys_language_uid."' and a.options_values_id=ov.products_options_values_id";
											$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
											if ($GLOBALS['TYPO3_DB']->sql_num_rows($qry)>0) {
												$row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry);
												$row['country_tax']=mslib_fe::taxDecimalCrop(($row['price_prefix'].$row['options_values_price'])*$product['country_tax_rate']);
												$row['region_tax']=mslib_fe::taxDecimalCrop(($row['price_prefix'].$row['options_values_price'])*$product['region_tax_rate']);
												if ($row['country_tax'] && $row['region_tax']) {
													$row['tax']=$row['country_tax']+$row['region_tax'];
												} else {
													$row['tax']=mslib_fe::taxDecimalCrop(($row['price_prefix'].$row['options_values_price'])*($product['tax_rate']));
												}
												$attributes_tax+=$row['tax'];
												if ($multiple) {
													$cart['products'][$shopping_cart_item]['attributes'][$key][]=$row;
												} else {
													$cart['products'][$shopping_cart_item]['attributes'][$key]=$row;
												}
											}
										}
									}
								}
							} // end if $key
						}
					}
					$return_data['cart_page_uid']=$this->cart_page_uid;
					$cart['products'][$shopping_cart_item]['total_attributes_tax']=$attributes_tax;
					$GLOBALS['TSFE']->fe_user->setKey('ses', $this->cart_page_uid, $cart);
					$GLOBALS['TSFE']->storeSessionData();
				}

				//$mslib_cart->setShippingMethod($this->post['tx_multishop_pi1']['sid']);
				//$mslib_cart->setPaymentMethod($this->post['tx_multishop_pi1']['pid']);
				$mslib_cart->getCart();
				$return_data['htmlCartContents']=$mslib_cart->getHtmlCartContents('ajaxGetMethodCosts');

				echo json_encode($return_data);
				exit();
				break;
		}
	}
	function addConfigurationRecordsPreHook(&$params, &$ref) {
		self::construct($ref);
		$params['records'][]=array(
			'configuration_title'=>'Change Product Attributes in Cart',
			'configuration_key'=>'ALLOW_CHANGE_PRODUCT_ATTRIBUTES_IN_CART',
			'configuration_value'=>'0',
			'description'=>'Allow  customer to change product attributes in cart',
			'group_id'=>'8',
			'use_function'=>'',
			'set_function'=>'tep_cfg_select_option(array(\'0\',\'1\'),',
			'depend_on_configuration_key'=>'',
			'use_function'=>''
		);
	}
}
if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/multishop_one_step_checkout/pi1/class.tx_multishoponestepcheckout_pi1.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/multishop_one_step_checkout/pi1/class.tx_multishoponestepcheckout_pi1.php']);
}
?>